package Model;

/** Customer.java
 * Class for holding basic data of a customer
 * @author Michael Claudius, Roskilde Computer Science College
 * @version 1.0. 2010.10.26
 * Copyright 2010 by Michael Claudius
 * All rights reserved
 */
public class Customer {

    private String customerNo;
    private String name;
    private String customerType;
    private int year;
    private int noOfStays;



    public Customer() {
        year = 9999;
    }

    public Customer(String name, String customerType, int year) {
        this.customerType = customerType;
        this.name = name;
        this.year = year;
    }

    public Customer(String customerNo, String name, String customerType, int year) {
        this.customerNo = customerNo;
        this.name = name;
        this.customerType = customerType;
        this.year = year;
    }

      public Customer(String customerNo, String name, String customerType, int year, int stays) {
        this.customerNo = customerNo;
        this.name = name;
        this.customerType = customerType;
        this.year = year;
        this.noOfStays = stays;
    }

    @Override
    public String toString() {
        return "Customer"
                + "\n" + "customerNo=" + customerNo
                + "\n" + "name=" + name
                + "\n" + "customerType=" + customerType
                + "\n" + "noOfStays=" + noOfStays
                + "\n" + "year=" + year
                + "\n";
    }
   public String toDBString() {
        return ("\'" + customerNo
                + "\',\'" + name
                + "\'," + year
                + ",\'" + customerType
                + "\'," + noOfStays
               );
    }

    public String toDBUpdateString() {
        return ("customerNo = " + "\'" + customerNo + "\',"
                + "name  = " + "\'" + name + "\',"
                + "year   = " + year + ","
                + "cType = " + "\'" + customerType + "\',"
                + "stays  = " + "\'" + noOfStays + "\'");
    }

     /**
     * Get the value of noOfStays
     * @return the value of noOfStays
     */
     public int getNoOfStays() {
        return noOfStays;
    }

    public void setNoOfStays(int noOfStays) {
        this.noOfStays = noOfStays;
    }

    public String getCustomerNo() {
        return customerNo;
    }

    public void setCustomerNo(String customerNo) {
        this.customerNo = customerNo;
    }

    /**
     * Get the value of name
     * @return the value of name
     */
    public String getName() {
        return name;
    }

    /**
     * Set the value of name
     * @param name new value of name
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * Get the value of customerType
     * @return the value of customerType
     */
    public String getCustomerType() {
        return customerType;
    }

    /**Set the value of customerType
     * @param customerType new value of customerType
     */
    public void setCustomerType(String customerType) {
        this.customerType = customerType;
    }

    /**Get the value of year
     * @return the value of year
     */
    public int getYear() {
        return year;
    }

    /**Set the value of year
     * @param year new value of year
     */
    public void setYear(int year) {
        this.year = year;
    }

   
  
     /** Set the value of noOfStays
     * @param noOfStays new value of noOfStays
     */
    public void increaseNoOfStays() {
        this.noOfStays = noOfStays+1;
    }
}
